package com.house365.xxx.newhouse.namecheck.core;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.house365.xxx.newhouse.namecheck.bean.PrjBean;
import com.house365.xxx.newhouse.namecheck.db.DefDbcpPoolHelper;
import com.house365.xxx.newhouse.namecheck.util.PinyinToolkit;

/**
 * 
 * @author dzw 20151123
 *
 */
@Component
public class NewProjectBeanLoader {
	private static Log logger = LogFactory.getLog(NewProjectBeanLoader.class);
	@Autowired
	private DefDbcpPoolHelper dbcpPoolHelper;
	private HashMap<Integer, HashSet<PrjBean>> mapCityPrjBean = new HashMap<Integer, HashSet<PrjBean>>();

	public HashSet<PrjBean> getSetPrjBean(int city) {
		return mapCityPrjBean.get(city);
	}

	public void load() {
	    logger.info("load new project start");
		Connection con = null;
		PreparedStatement ps = null;
		ResultSet rs = null;
		String sql = "select pf_id,prj_id,prj_city,prj_listid,prj_channel,prj_channel_str,prj_itemname,prj_promotionname,prj_itemname_search,prj_pinyin,prj_dist_str,prj_block_str,prj_loc,prj_kfsname,tag,dateline,del,prj_ob,wid,info,info2,pinyin_all,sale_status,middle_sort from project_forsearch";
		try {
			con = dbcpPoolHelper.getConn();
			ps = con.prepareStatement(sql);
			rs = ps.executeQuery();
			while (rs.next()) {
				int pf_id = rs.getInt("pf_id");
				int prj_id = rs.getInt("prj_id");
				int prj_city = rs.getInt("prj_city");
				int prj_listid = rs.getInt("prj_listid");
				int prj_channel = rs.getInt("prj_channel");
				String prj_channel_str = rs.getString("prj_channel_str");
				String prj_itemname = rs.getString("prj_itemname");
				String prj_promotionname = rs.getString("prj_promotionname");
				String prj_itemname_search = rs
						.getString("prj_itemname_search");
				String prj_pinyin = rs.getString("prj_pinyin");
				String prj_dist_str = rs.getString("prj_dist_str");
				String prj_block_str = rs.getString("prj_block_str");

				String prj_loc = rs.getString("prj_loc");
				String prj_kfsname = rs.getString("prj_kfsname");
				String tag = rs.getString("tag");
				int dateline = rs.getInt("dateline");
				int del = rs.getInt("del");
				float prj_ob = rs.getFloat("prj_ob");

				int wid = rs.getInt("wid");
				String info = rs.getString("info");
				String info2 = rs.getString("info2");
				String pinyin_all = rs.getString("pinyin_all");
				
				int sale_status = rs.getInt("sale_status");
				
				int middle_sort = rs.getInt("middle_sort");

				if (StringUtils.isNotBlank(prj_itemname_search)) {
					prj_itemname_search = prj_itemname_search.trim();
					List<String> lstPY = PinyinToolkit
							.getLstCn2Spell(prj_itemname_search);
					String pyFst = PinyinToolkit
							.cn2FirstSpell(prj_itemname_search);
					PrjBean prjBean = new PrjBean(pf_id, prj_id, prj_city,
							prj_listid, prj_channel, prj_channel_str,
							prj_itemname, prj_promotionname, prj_itemname_search, pinyin_all,
							prj_dist_str, prj_block_str, prj_loc, prj_kfsname,
							tag, dateline, del, prj_ob, lstPY, pyFst, wid,
							info, info2,sale_status,middle_sort,prj_pinyin);
					if (mapCityPrjBean.containsKey(prj_city)) {
						HashSet<PrjBean> setPrjBean = mapCityPrjBean
								.get(prj_city);
						if (setPrjBean.contains(prjBean)) {
							setPrjBean.remove(prjBean);
						}
						setPrjBean.add(prjBean);
					} else {
						HashSet<PrjBean> setPrjBean = new HashSet<PrjBean>();
						setPrjBean.add(prjBean);
						mapCityPrjBean.put(prj_city, setPrjBean);
					}
				}
			}
		} catch (SQLException e) {
			logger.error(e.getMessage(), e);
		} finally {
			dbcpPoolHelper.release(rs, ps, con);
		}
		logger.info("load new project end");
	}
}
