package com.house365.xxx.newhouse.namecheck.db;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import org.apache.commons.dbcp2.BasicDataSource;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class DefDbcpPoolHelper {
	private static Log log = LogFactory.getLog(DefDbcpPoolHelper.class);
	@Autowired
	private BasicDataSource dataSource;

	public Connection getConn() throws SQLException  {
		return dataSource.getConnection();
	}

	public void release(ResultSet rs, Statement st, Connection conn) {
		if (rs != null) {
			try {
				rs.close();
			} catch (Exception e) {
				log.error(e.getMessage(), e);
			}
		}
		if (st != null) {
			try {
				st.close();
			} catch (Exception e) {
				log.error(e.getMessage(), e);
			}
		}
		if (conn != null) {
			try {
				conn.close();
			} catch (Exception e) {
				log.error(e.getMessage(), e);
			}
		}
	}
}